/**
 * 梯形 
 */
export class changeTrapezoidPlace {
    constructor() {
    }
    // 梯形左 or 左上
    trapezoidLeftTop (storageMark, xMin, yMin) {
        var leftWidth = Math.max(xMin, storageMark.insideWidth - window.event.clientX + storageMark.grabx)
        storageMark.el.firstElementChild.style.width = leftWidth + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = leftWidth - 2 + 'px'
        storageMark.el.style.left = Math.min(storageMark.left + window.event.clientX - storageMark.grabx, storageMark.left + storageMark.width - xMin) + 'px'
        this.sameTopCode(storageMark, xMin, yMin)
        let line = storageMark.el.querySelector('.line')
        line.style.width = leftWidth - 2 + 'px'
        line.style.marginLeft = `-${(leftWidth - 2)/2}px`
    }
    // 梯形右 or 右上
    trapezoidRightTop (storageMark, xMin, yMin) {
        this.sameRightCode(storageMark, xMin, yMin)
        this.sameTopCode(storageMark, xMin, yMin)
    }
    // 梯形右 or 右下
    trapezoidRightBottom (storageMark, xMin, yMin) {
        this.sameRightCode(storageMark, xMin, yMin)
        this.sameBottomCode(storageMark, xMin, yMin)
    }
    // 梯形左左下
    trapezoidLeftBottom (storageMark, xMin, yMin) {
        var leftWidth1 = Math.max(xMin, storageMark.insideWidth - window.event.clientX + storageMark.grabx)
        storageMark.el.firstElementChild.style.width = leftWidth1 + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = leftWidth1 - 2 + 'px'
        storageMark.el.style.left = Math.min(storageMark.left + window.event.clientX - storageMark.grabx, storageMark.left + storageMark.width - xMin) + 'px'
        storageMark.el.style.height = Math.max(yMin, storageMark.height + window.event.clientY - storageMark.graby) + 'px'
        storageMark.el.firstElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) + 'px solid #5b5b5b'
        storageMark.el.firstElementChild.lastElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) -2 + 'px solid #fff'
    }
    // 梯形图像使用相同右部修改的代码
    sameRightCode (storageMark, xMin, yMin) {
        var oWidth = Math.max(xMin, storageMark.insideWidth + window.event.clientX - storageMark.grabx)
        storageMark.el.firstElementChild.style.width = oWidth + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = oWidth - 2 + 'px'
        let line = storageMark.el.querySelector('.line')
        line.style.width = oWidth - 2 + 'px'
        line.style.marginLeft = `-${(oWidth - 2)/2}px`
    }
    // 梯形图像使用相同上部修改的代码
    sameTopCode (storageMark, xMin, yMin) {
        storageMark.el.style.top = Math.min(storageMark.top + window.event.clientY - storageMark.graby, storageMark.top + storageMark.height - yMin) + 'px'
        storageMark.el.firstElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom - window.event.clientY + storageMark.graby) + 'px solid #5b5b5b'
        storageMark.el.firstElementChild.lastElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom - window.event.clientY + storageMark.graby) -2 + 'px solid #fff'
        storageMark.el.style.height = Math.max(yMin, storageMark.height - window.event.clientY + storageMark.graby) + 'px'
    }
    // 梯形图像使用相同下部修改的代码
    sameBottomCode (storageMark, xMin, yMin) {
        var oWidth = Math.max(xMin, storageMark.insideWidth + window.event.clientX - storageMark.grabx)
        storageMark.el.firstElementChild.style.width = oWidth + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = oWidth - 2 + 'px'
        storageMark.el.style.height = Math.max(yMin, storageMark.height + window.event.clientY - storageMark.graby) + 'px'
        storageMark.el.firstElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) + 'px solid #5b5b5b'
        storageMark.el.firstElementChild.lastElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) -2 + 'px solid #fff'
    }
}
// 圆
export class changeCircle {
    constructor() {
    }
    // 改变左宽度
    circleWidth (storageMark, xMin, yMin) {
        var circle_width = Math.max(xMin, storageMark.width - window.event.clientX + storageMark.grabx) + 'px'
        storageMark.el.style.width = circle_width
        storageMark.el.firstElementChild.style.width = circle_width
        storageMark.el.style.left = Math.min(storageMark.left + window.event.clientX - storageMark.grabx, storageMark.left + storageMark.width - xMin) + 'px'
    }
    // 改变右宽
    circleRightWidth (storageMark, xMin) {
        var circle_width = Math.max(xMin, storageMark.width + window.event.clientX - storageMark.grabx) + 'px'
        storageMark.el.style.width = circle_width
        storageMark.el.firstElementChild.style.width = circle_width
    }
    // 改变top高度
    circleTopHeight (storageMark, xMin, yMin) {
        storageMark.el.style.top = Math.min(storageMark.top + window.event.clientY - storageMark.graby, storageMark.top + storageMark.height - yMin) + 'px'
        storageMark.el.style.height = Math.max(yMin, storageMark.height - window.event.clientY + storageMark.graby) + 'px'
        storageMark.el.firstElementChild.style.height = storageMark.el.style.height
    }
    // 改变高度
    circleHeight (storageMark, xMin, yMin) {
        storageMark.el.style.height = Math.max(yMin, storageMark.height + window.event.clientY - storageMark.graby) + 'px'
        storageMark.el.firstElementChild.style.height = storageMark.el.style.height
    }
}